
/* Complex variable natural logarithm of gamma function */
#include "qhead.h"
extern QELT qhalf[], qone[], qpi[];
extern qcmplx qcone;
#ifdef ANSIPROT
int initqgam(void);
#else
int qcneg(), qcsin(), qcmul(), qcmov(), qcdiv(), qclog(), qcsub(), qcadd();
int qcexp(), initqgam();
#endif
/* See qgamma.c for coefficients. */
#define NG 30
extern QELT qgamcof[NG][NQ];
extern QELT qgam12[];

extern int qgamini;

int qclgam( x, y )
qcmplx *x, *y;
{
qcmplx v, w, g, xx, t;
QELT *p;
int i;

if( qgamini == 0 )
  initqgam();

qmov( qone, &qcone.r[0] );
qclear( &qcone.i[0] );
qcmov( x, &xx );
#if 0
if( x->r[0] != 0 )
	{
	qcneg( &xx );
	qclgam( &xx, &t );
	qmul( &xx.r[0], qpi, &g.r[0] );	/* PI/(x * sin(PI*x))	*/
	qmul( &xx.i[0], qpi, &g.i[0] );
	qcsin( &g, &g );
	qcmul( &xx, &g, &g );
	qmov( qpi, &v.r[0] );
	qclear( &v.i[0] );
	qcdiv( &g, &v, y );
	qcneg( y );
	qclog( y, y );
	qcsub( &t, y, y );	/* ... /gamma(x)	*/
	return(0);
	}
#endif
/* range reduction: transform argument to be greater than 32 */
/*qcmov( x, &xx );*/
qcmov( &qcone, &v );
#if NQ == 28
while( xx.r[1] <= (QELT) (EXPONE + 8) )
#else
while( xx.r[1] <= (QELT) (EXPONE + 4) )
#endif
	{
/*	qcdiv( &xx, &v, &v );*/
	qcmul( &xx, &v, &v );
	qcadd( &qcone, &xx, &xx );
	}
qcdiv( &v, &qcone, &v );
/*  Asymptotic polynomial in 1/x**2 for Stirling's formula	*/
qcmul( &xx, &xx, &w );
qcdiv( &w, &qcone, &w );

p = &qgamcof[0][0];
qmul( &w.r[0], p, &g.r[0] );
qmul( &w.i[0], p, &g.i[0] );
p += NQ;
qadd( &g.r[0], p, &g.r[0] );
for( i=0; i<NG-2; i++ )
	{
	qcmul( &w, &g, &g );
	p += NQ;
	qadd( &g.r[0], p, &g.r[0] );
	}

qcdiv( &xx, &g, &g );

/* g + (x - 0.5)*log(x) - x + qgam12	*/
qsub( qhalf, &xx.r[0], &t.r[0] );
qmov( &xx.i[0], &t.i[0] );
qclog( &xx, &w );
qcmul( &t, &w, &t );
qcsub( &xx, &t, &t );
qadd( qgam12, &t.r[0], &t.r[0] );
qcadd( &g, &t, &g );

qclog( &v, &t );
qcadd( &t, &g, y );
return(0);
}

/*							qgamma()	*/

/* Complex variable gamma function check routine */


int qcgamma( x, y )
qcmplx *x, *y;
{
qcmplx t, s, xx;

if( qgamini == 0 )
  initqgam();

qcmov( x, &xx );
if( x->r[0] != 0 )
	{
	qcneg(&xx);
	qcgamma( &xx, &t );
	qmul( &xx.r[0], qpi, &s.r[0] );
	qmul( &xx.i[0], qpi, &s.i[0] );
	qcsin( &s, &s );
	qcmul( &xx, &s, &s );
	qcmul( &s, &t, &t );
	qmov( qpi, &s.r[0] );
	qclear( &s.i[0] );
	qcdiv( &t, &s, y );
/*	y[0] = ~y[0];*/
	qcneg( y );
	return(0);
	}
qclgam( &xx, y );
qcexp( y, y );
return(0);
}

