/*  qndtri.c */
/* Inverse Gaussian probability distribution function */

#include "qhead.h"
#include "mconf.h"

static QELT qcc[NQ];
static QELT qcl[NQ];
static QELT qd[NQ];
static QELT qy[NQ];
static QELT qx[NQ];
static QELT temp[NQ];
static int qcflg = 0;

extern double PI;
extern QELT qone[], qpi[];
int qndtr();

int qndtri(qy0, qx0)
QELT *qy0, *qx0;
{
double y0, x0;
int i, k;
double sqrt(), ndtri(), exp();


if( qcflg == 0 )
	{
	qmov( qpi, temp );
	temp[1] += 1;
	qsqrt( temp, temp );
	qdiv( temp, qone, qcc );
	qlog( qcc, qcl );
	qcflg = 1;
	}



#ifdef DEC
if( qy0[1] < (EXPONE-127) ) /* 6e-39 */
	{
#if NBITS > 144
	k = 7;
#else
	k = 6;
#endif

#else
if( qy0[1] < (QELT) (EXPONE - 1021) ) /* 4.5e-308 */
	{
#if NBITS > 144
	k = 7;
#else
	k = 5;
#endif
#endif
/* x = sqrt( -2 log y ) */
	qlog( qy0, qd );
	qd[1] += 1;
	qd[0] = 0;
	qsqrt( qd, qx );
/* fine adjustment:
 * x = x - (log x  +  log sqrt 2pi)/x
 */
	qlog( qx, temp );
	qsub( qcl, temp, temp );
	qdiv( qx, temp, temp );
	qsub( qx, temp, qx );
	qx[0] = -1;
	}
else
	{
	qtoe( qy0, (unsigned short *) &y0 );
	x0 = ndtri( y0 );
	etoq( (unsigned short *) &x0, qx );
#if NBITS > 144
	k = 3;
#else
	k = 2;
#endif
	}


for( i=0; i<k; i++ )
	{
	qndtr( qx, qy );
/* debugging code */
/*
	qtoasc( qx, s, 5 );
	printf( "%s", s );
	qtoasc( qy, s, 5 );
	printf( " %s", s );
	qsub( qy0, qy, temp );
	qdiv( qy0, temp, temp );
	qtoasc( temp, s, 5 );
	printf( " %s\n", s );
*/
/*   */
	qmul( qx, qx, qd );
	qd[1] -= 1;
	qneg(qd);
	qexp( qd, qd );
	qmul( qcc, qd, qd );
	if( qd[1] > 3 )
		{
		qsub( qy0, qy, temp );
		qdiv( qd, temp, temp );
		qsub( temp, qx, qx );
		}
	}

qmov( qx, qx0 );	
return 0;
}
